(function (_, kotlin_clikt_clikt, kotlin_kotlin, kotlin_mordant_mordant) {
  'use strict';
  //region block: imports
  var CoreCliktCommand = kotlin_clikt_clikt.$_$.b;
  var VOID = kotlin_kotlin.$_$.f;
  var Unit_instance = kotlin_kotlin.$_$.d4;
  var protoOf = kotlin_kotlin.$_$.z9;
  var initMetadataForClass = kotlin_kotlin.$_$.z8;
  var selfAndAncestors = kotlin_clikt_clikt.$_$.g;
  var mapNotNull = kotlin_kotlin.$_$.eb;
  var firstOrNull = kotlin_kotlin.$_$.za;
  var Terminal_init_$Create$ = kotlin_mordant_mordant.$_$.g;
  var last = kotlin_kotlin.$_$.db;
  var MultiplatformSystem_instance = kotlin_mordant_mordant.$_$.i;
  var FileNotFound = kotlin_clikt_clikt.$_$.c;
  var Terminal = kotlin_mordant_mordant.$_$.b;
  var Whitespace_NORMAL_getInstance = kotlin_mordant_mordant.$_$.e;
  var Text_init_$Create$ = kotlin_mordant_mordant.$_$.h;
  var AbstractHelpFormatter = kotlin_clikt_clikt.$_$.i;
  var verticalLayout = kotlin_mordant_mordant.$_$.a;
  var charSequenceLength = kotlin_kotlin.$_$.p8;
  var definitionList = kotlin_mordant_mordant.$_$.c;
  var withPadding = kotlin_mordant_mordant.$_$.d;
  var collectionSizeOrDefault = kotlin_kotlin.$_$.b5;
  var ArrayList_init_$Create$ = kotlin_kotlin.$_$.i;
  var ensureNotNull = kotlin_kotlin.$_$.qe;
  var drop = kotlin_kotlin.$_$.ob;
  var plus = kotlin_kotlin.$_$.xe;
  var Whitespace_PRE_WRAP_getInstance = kotlin_mordant_mordant.$_$.f;
  var isBlank = kotlin_kotlin.$_$.vb;
  var replace = kotlin_kotlin.$_$.hc;
  //endregion
  //region block: pre-declaration
  initMetadataForClass(CliktCommand, 'CliktCommand', VOID, CoreCliktCommand);
  initMetadataForClass(MordantHelpFormatter, 'MordantHelpFormatter', VOID, AbstractHelpFormatter);
  //endregion
  function CliktCommand(name) {
    name = name === VOID ? null : name;
    CoreCliktCommand.call(this, name);
    installMordant(this);
  }
  function installMordant(_this__u8e3s4, force) {
    force = force === VOID ? false : force;
    _this__u8e3s4.k1q(installMordant$lambda(force));
  }
  function get_terminal(_this__u8e3s4) {
    // Inline function 'com.github.ajalt.clikt.core.Context.findObject' call
    var key = 'mordant_terminal';
    var tmp = selfAndAncestors(_this__u8e3s4);
    var tmp0_elvis_lhs = firstOrNull(mapNotNull(tmp, _get_terminal_$lambda_5keric(key)));
    var tmp_0;
    if (tmp0_elvis_lhs == null) {
      // Inline function 'kotlin.also' call
      var this_0 = Terminal_init_$Create$();
      // Inline function 'com.github.ajalt.clikt.core.<get-terminal>.<anonymous>' call
      var tmp0 = last(selfAndAncestors(_this__u8e3s4)).i1o_1;
      // Inline function 'kotlin.collections.set' call
      var key_0 = 'mordant_terminal';
      tmp0.m2(key_0, this_0);
      tmp_0 = this_0;
    } else {
      tmp_0 = tmp0_elvis_lhs;
    }
    return tmp_0;
  }
  function installMordant$lambda$lambda(it) {
    return new MordantHelpFormatter(it);
  }
  function installMordant$lambda$lambda_0(it) {
    return MultiplatformSystem_instance.r2c(it);
  }
  function installMordant$lambda$lambda_1(it) {
    var tmp0_elvis_lhs = MultiplatformSystem_instance.t2c(it);
    var tmp;
    if (tmp0_elvis_lhs == null) {
      throw new FileNotFound(it);
    } else {
      tmp = tmp0_elvis_lhs;
    }
    return tmp;
  }
  function installMordant$lambda$lambda_2(it) {
    MultiplatformSystem_instance.s2c(it);
    return Unit_instance;
  }
  function installMordant$lambda$lambda_3(context, message, trailingNewline, err) {
    if (trailingNewline) {
      get_terminal(context).r2m(message, VOID, VOID, VOID, VOID, err);
    } else {
      get_terminal(context).p2m(message, VOID, VOID, VOID, VOID, err);
    }
    return Unit_instance;
  }
  function installMordant$lambda($force) {
    return function ($this$configureContext) {
      var tmp;
      if (!$force && !($this$configureContext.l1q_1 == null)) {
        return Unit_instance;
      }
      var tmp_0 = $this$configureContext;
      tmp_0.q1q_1 = installMordant$lambda$lambda;
      var tmp_1 = $this$configureContext;
      tmp_1.y1q_1 = installMordant$lambda$lambda_0;
      var tmp_2 = $this$configureContext;
      tmp_2.t1q_1 = installMordant$lambda$lambda_1;
      var tmp_3 = $this$configureContext;
      tmp_3.b1r_1 = installMordant$lambda$lambda_2;
      var tmp_4 = $this$configureContext;
      tmp_4.a1r_1 = installMordant$lambda$lambda_3;
      return Unit_instance;
    };
  }
  function _get_terminal_$lambda_5keric($key) {
    return function (it) {
      var tmp = it.i1o_1.e2($key);
      return tmp instanceof Terminal ? tmp : null;
    };
  }
  function MordantHelpFormatter$formatHelp$lambda(this$0, $error, $prolog, $epilog, $parameters, $programName) {
    return function ($this$verticalLayout) {
      $this$verticalLayout.h2j(1);
      $this$verticalLayout.e2j(this$0.z1w($error, $prolog, $epilog, $parameters, $programName));
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$renderUsage$lambda($prog, $usageParts) {
    return function ($this$definitionList) {
      $this$definitionList.b2n($prog, Text_init_$Create$($usageParts, Whitespace_NORMAL_getInstance()));
      $this$definitionList.v2m_1 = true;
      $this$definitionList.y2m(1);
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$renderProlog$lambda($this$withPadding) {
    $this$withPadding.e2l_1 = 2;
    return Unit_instance;
  }
  function MordantHelpFormatter$renderParameters$lambda(this$0, $parameters) {
    return function ($this$definitionList) {
      var _iterator__ex2g4s = this$0.m1y($parameters).m();
      while (_iterator__ex2g4s.n()) {
        var section = _iterator__ex2g4s.o();
        $this$definitionList.b2n(section.g1w_1, section.h1w_1);
      }
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$renderOptionGroup$lambda($this$withPadding) {
    $this$withPadding.b2l_1 = 1;
    $this$withPadding.e2l_1 = 2;
    $this$withPadding.d2l_1 = 1;
    return Unit_instance;
  }
  function MordantHelpFormatter$renderOptionGroup$lambda_0($markdown, this$0, $options) {
    return function ($this$verticalLayout) {
      $this$verticalLayout.g2j($markdown);
      $this$verticalLayout.g2j(this$0.w1y($options));
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$buildParameterList$lambda($rows, this$0) {
    return function ($this$definitionList) {
      $this$definitionList.v2m_1 = true;
      var _iterator__ex2g4s = $rows.m();
      while (_iterator__ex2g4s.n()) {
        var row = _iterator__ex2g4s.o();
        $this$definitionList.c2n(this$0.r1z(row), this$0.s1z(row));
      }
      return Unit_instance;
    };
  }
  function MordantHelpFormatter(context, requiredOptionMarker, showDefaultValues, showRequiredTag) {
    requiredOptionMarker = requiredOptionMarker === VOID ? null : requiredOptionMarker;
    showDefaultValues = showDefaultValues === VOID ? false : showDefaultValues;
    showRequiredTag = showRequiredTag === VOID ? false : showRequiredTag;
    AbstractHelpFormatter.call(this, context, requiredOptionMarker, showDefaultValues, showRequiredTag);
  }
  protoOf(MordantHelpFormatter).g2o = function () {
    return get_terminal(this.n1w_1).b2g_1;
  };
  protoOf(MordantHelpFormatter).e1q = function (error, prolog, epilog, parameters, programName) {
    var widget = verticalLayout(MordantHelpFormatter$formatHelp$lambda(this, error, prolog, epilog, parameters, programName));
    return get_terminal(this.n1w_1).s2m(widget);
  };
  protoOf(MordantHelpFormatter).b1x = function (parameters, error) {
    return Text_init_$Create$(this.f1x(parameters, error));
  };
  protoOf(MordantHelpFormatter).a1x = function (parameters, programName) {
    var title = this.h2o(this.y1w().m1z());
    var prog = title + ' ' + programName;
    var usageParts = this.j1x(parameters);
    var tmp;
    // Inline function 'kotlin.text.isEmpty' call
    if (charSequenceLength(usageParts) === 0) {
      tmp = Text_init_$Create$(prog, Whitespace_NORMAL_getInstance());
    } else {
      tmp = definitionList(MordantHelpFormatter$renderUsage$lambda(prog, usageParts));
    }
    return tmp;
  };
  protoOf(MordantHelpFormatter).c1x = function (prolog) {
    var tmp = this.i2o(prolog);
    return withPadding(tmp, false, MordantHelpFormatter$renderProlog$lambda);
  };
  protoOf(MordantHelpFormatter).e1x = function (epilog) {
    return this.i2o(epilog);
  };
  protoOf(MordantHelpFormatter).d1x = function (parameters) {
    return definitionList(MordantHelpFormatter$renderParameters$lambda(this, parameters));
  };
  protoOf(MordantHelpFormatter).k1y = function (help, parameters) {
    // Inline function 'kotlin.collections.map' call
    // Inline function 'kotlin.collections.mapTo' call
    var destination = ArrayList_init_$Create$(collectionSizeOrDefault(parameters, 10));
    var _iterator__ex2g4s = parameters.m();
    while (_iterator__ex2g4s.n()) {
      var item = _iterator__ex2g4s.o();
      // Inline function 'com.github.ajalt.clikt.output.MordantHelpFormatter.renderOptionGroup.stub_for_inlining' call
      var tmp$ret$0 = this.p1y(item);
      destination.e(tmp$ret$0);
    }
    var options = destination;
    if (help == null)
      return this.w1y(options);
    var tmp = this.i2o(help);
    var markdown = withPadding(tmp, false, MordantHelpFormatter$renderOptionGroup$lambda);
    return verticalLayout(MordantHelpFormatter$renderOptionGroup$lambda_0(markdown, this, options));
  };
  protoOf(MordantHelpFormatter).v1w = function (name) {
    // Inline function 'kotlin.text.lowercase' call
    // Inline function 'kotlin.js.asDynamic' call
    return '<' + name.toLowerCase() + '>';
  };
  protoOf(MordantHelpFormatter).u1y = function (name) {
    return this.g2o().q2f('danger').p28(name);
  };
  protoOf(MordantHelpFormatter).d1z = function (name) {
    return this.g2o().q2f('muted').p28(name);
  };
  protoOf(MordantHelpFormatter).t1w = function (name) {
    return this.g2o().q2f('info').p28(name);
  };
  protoOf(MordantHelpFormatter).w1w = function (name) {
    return this.g2o().q2f('info').p28(name);
  };
  protoOf(MordantHelpFormatter).x1w = function (name) {
    return this.g2o().q2f('info').p28(name);
  };
  protoOf(MordantHelpFormatter).l1y = function (title) {
    return this.g2o().q2f('warning').p28(title);
  };
  protoOf(MordantHelpFormatter).h2o = function (title) {
    return this.g2o().q2f('warning').p28(title);
  };
  protoOf(MordantHelpFormatter).h1x = function (title) {
    return this.g2o().q2f('danger').p28(title);
  };
  protoOf(MordantHelpFormatter).m1x = function (parameter) {
    return this.g2o().q2f('muted').p28(parameter);
  };
  protoOf(MordantHelpFormatter).f1z = function (metavar) {
    return this.g2o().q2f('warning').e2c(this.g2o().q2f('muted')).p28(metavar);
  };
  protoOf(MordantHelpFormatter).r1z = function (row) {
    var tmp;
    // Inline function 'kotlin.text.isNullOrEmpty' call
    var this_0 = row.k1w_1;
    if (this_0 == null || charSequenceLength(this_0) === 0) {
      tmp = '  ';
    } else {
      // Inline function 'kotlin.text.ifEmpty' call
      var this_1 = drop('  ', ensureNotNull(row.k1w_1).length);
      var tmp_0;
      // Inline function 'kotlin.text.isEmpty' call
      if (charSequenceLength(this_1) === 0) {
        // Inline function 'com.github.ajalt.clikt.output.MordantHelpFormatter.renderDefinitionTerm.<anonymous>' call
        tmp_0 = ' ';
      } else {
        tmp_0 = this_1;
      }
      var tmp$ret$3 = tmp_0;
      tmp = plus(row.k1w_1, tmp$ret$3);
    }
    var termPrefix = tmp;
    return Text_init_$Create$(termPrefix + row.i1w_1, Whitespace_PRE_WRAP_getInstance());
  };
  protoOf(MordantHelpFormatter).s1z = function (row) {
    return isBlank(row.j1w_1) ? Text_init_$Create$('') : this.i2o(row.j1w_1);
  };
  protoOf(MordantHelpFormatter).w1y = function (rows) {
    return definitionList(MordantHelpFormatter$buildParameterList$lambda(rows, this));
  };
  protoOf(MordantHelpFormatter).i2o = function (text) {
    return Text_init_$Create$(replace(text, '\n\n', '\x85\x85'), Whitespace_NORMAL_getInstance());
  };
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = CliktCommand;
  //endregion
  return _;
}(module.exports, require('./clikt-clikt.js'), require('./kotlin-kotlin-stdlib.js'), require('./mordant-mordant.js')));

//# sourceMappingURL=clikt-clikt-mordant.js.map
