(function (_, kotlin_kotlin, kotlin_com_zegreatrob_tools_digger_core) {
  'use strict';
  //region block: imports
  var imul = Math.imul;
  var split = kotlin_kotlin.$_$.lc;
  var collectionSizeOrDefault = kotlin_kotlin.$_$.b5;
  var ArrayList_init_$Create$ = kotlin_kotlin.$_$.i;
  var toInt = kotlin_kotlin.$_$.xc;
  var Unit_instance = kotlin_kotlin.$_$.d4;
  var charSequenceLength = kotlin_kotlin.$_$.p8;
  var charSequenceGet = kotlin_kotlin.$_$.o8;
  var digitToIntOrNull = kotlin_kotlin.$_$.nb;
  var emptyList = kotlin_kotlin.$_$.s5;
  var VOID = kotlin_kotlin.$_$.f;
  var toString = kotlin_kotlin.$_$.da;
  var protoOf = kotlin_kotlin.$_$.z9;
  var getStringHashCode = kotlin_kotlin.$_$.x8;
  var hashCode = kotlin_kotlin.$_$.y8;
  var THROW_CCE = kotlin_kotlin.$_$.ae;
  var equals = kotlin_kotlin.$_$.s8;
  var initMetadataForClass = kotlin_kotlin.$_$.z8;
  var enumEntries = kotlin_kotlin.$_$.e8;
  var Enum = kotlin_kotlin.$_$.sd;
  var ArrayList_init_$Create$_0 = kotlin_kotlin.$_$.j;
  var isCharSequence = kotlin_kotlin.$_$.j9;
  var trim = kotlin_kotlin.$_$.id;
  var Companion_instance = kotlin_kotlin.$_$.y3;
  var get = kotlin_kotlin.$_$.sb;
  var _Result___init__impl__xyqfz8 = kotlin_kotlin.$_$.x1;
  var createFailure = kotlin_kotlin.$_$.pe;
  var _Result___get_isFailure__impl__jpiriv = kotlin_kotlin.$_$.z1;
  var _Result___get_value__impl__bjfvqg = kotlin_kotlin.$_$.b2;
  var substringBefore = kotlin_kotlin.$_$.qc;
  var contains = kotlin_kotlin.$_$.lb;
  var to = kotlin_kotlin.$_$.bf;
  var _Result___get_isSuccess__impl__sndoy8 = kotlin_kotlin.$_$.a2;
  var Result__exceptionOrNull_impl_p6xea9 = kotlin_kotlin.$_$.y1;
  var mapOf = kotlin_kotlin.$_$.s6;
  var LinkedHashMap_init_$Create$ = kotlin_kotlin.$_$.s;
  var joinToString = kotlin_kotlin.$_$.e6;
  var initMetadataForObject = kotlin_kotlin.$_$.e9;
  var Defaults_getInstance = kotlin_com_zegreatrob_tools_digger_core.$_$.a;
  var initMetadataForCompanion = kotlin_kotlin.$_$.a9;
  var toString_0 = kotlin_kotlin.$_$.af;
  //endregion
  //region block: pre-declaration
  initMetadataForClass(VersionResult, 'VersionResult');
  initMetadataForClass(SnapshotReason, 'SnapshotReason', VOID, Enum);
  initMetadataForClass(SnapshotReason$DIRTY, 'DIRTY', VOID, SnapshotReason);
  initMetadataForClass(SnapshotReason$AHEAD, 'AHEAD', VOID, SnapshotReason);
  initMetadataForClass(SnapshotReason$BEHIND, 'BEHIND', VOID, SnapshotReason);
  initMetadataForClass(SnapshotReason$NOT_RELEASE_BRANCH, 'NOT_RELEASE_BRANCH', VOID, SnapshotReason);
  initMetadataForClass(SnapshotReason$NO_NEW_VERSION, 'NO_NEW_VERSION', VOID, SnapshotReason);
  initMetadataForClass(StatusCheck, 'StatusCheck');
  initMetadataForClass(ChangeType, 'ChangeType', VOID, Enum);
  initMetadataForClass(ChangeType$Major, 'Major', VOID, ChangeType);
  initMetadataForClass(ChangeType$Minor, 'Minor', VOID, ChangeType);
  initMetadataForClass(ChangeType$Patch, 'Patch', VOID, ChangeType);
  initMetadataForClass(ChangeType$None, 'None', VOID, ChangeType);
  initMetadataForObject(TagErrors, 'TagErrors');
  initMetadataForClass(TagResult, 'TagResult');
  initMetadataForObject(Success, 'Success', VOID, TagResult);
  initMetadataForClass(Error_0, 'Error', VOID, TagResult);
  initMetadataForClass(TaggerCore, 'TaggerCore');
  initMetadataForObject(Defaults, 'Defaults');
  initMetadataForCompanion(Companion);
  initMetadataForClass(VersionRegex, 'VersionRegex');
  //endregion
  function asSemverComponents(_this__u8e3s4) {
    // Inline function 'kotlin.collections.map' call
    var this_0 = split(stripPrefix(_this__u8e3s4), ['.']);
    // Inline function 'kotlin.collections.mapTo' call
    var destination = ArrayList_init_$Create$(collectionSizeOrDefault(this_0, 10));
    var _iterator__ex2g4s = this_0.m();
    while (_iterator__ex2g4s.n()) {
      var item = _iterator__ex2g4s.o();
      // Inline function 'com.zegreatrob.tools.tagger.core.asSemverComponents.stub_for_inlining' call
      var tmp$ret$0 = toInt(item);
      destination.e(tmp$ret$0);
    }
    return destination;
  }
  function stripPrefix(_this__u8e3s4) {
    var tmp$ret$1;
    $l$block: {
      // Inline function 'kotlin.text.indexOfFirst' call
      var inductionVariable = 0;
      var last = charSequenceLength(_this__u8e3s4) - 1 | 0;
      if (inductionVariable <= last)
        do {
          var index = inductionVariable;
          inductionVariable = inductionVariable + 1 | 0;
          // Inline function 'com.zegreatrob.tools.tagger.core.stripPrefix.<anonymous>' call
          var it = charSequenceGet(_this__u8e3s4, index);
          if (!(digitToIntOrNull(it) == null)) {
            tmp$ret$1 = index;
            break $l$block;
          }
        }
         while (inductionVariable <= last);
      tmp$ret$1 = -1;
    }
    var startIndex = tmp$ret$1;
    // Inline function 'kotlin.text.substring' call
    // Inline function 'kotlin.js.asDynamic' call
    return _this__u8e3s4.substring(startIndex);
  }
  function VersionResult(version, snapshotReasons) {
    snapshotReasons = snapshotReasons === VOID ? emptyList() : snapshotReasons;
    this.a1l_1 = version;
    this.b1l_1 = snapshotReasons;
  }
  protoOf(VersionResult).toString = function () {
    return 'VersionResult(version=' + this.a1l_1 + ', snapshotReasons=' + toString(this.b1l_1) + ')';
  };
  protoOf(VersionResult).hashCode = function () {
    var result = getStringHashCode(this.a1l_1);
    result = imul(result, 31) + hashCode(this.b1l_1) | 0;
    return result;
  };
  protoOf(VersionResult).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof VersionResult))
      return false;
    var tmp0_other_with_cast = other instanceof VersionResult ? other : THROW_CCE();
    if (!(this.a1l_1 === tmp0_other_with_cast.a1l_1))
      return false;
    if (!equals(this.b1l_1, tmp0_other_with_cast.b1l_1))
      return false;
    return true;
  };
  function SnapshotReason$DIRTY() {
    SnapshotReason.call(this, 'DIRTY', 0);
    SnapshotReason_DIRTY_instance = this;
  }
  protoOf(SnapshotReason$DIRTY).e1l = function (_this__u8e3s4) {
    return !_this__u8e3s4.f1l_1.m1k_1;
  };
  var SnapshotReason_DIRTY_instance;
  function SnapshotReason$AHEAD() {
    SnapshotReason.call(this, 'AHEAD', 1);
    SnapshotReason_AHEAD_instance = this;
  }
  protoOf(SnapshotReason$AHEAD).e1l = function (_this__u8e3s4) {
    return !(_this__u8e3s4.f1l_1.n1k_1 === 0);
  };
  var SnapshotReason_AHEAD_instance;
  function SnapshotReason$BEHIND() {
    SnapshotReason.call(this, 'BEHIND', 2);
    SnapshotReason_BEHIND_instance = this;
  }
  protoOf(SnapshotReason$BEHIND).e1l = function (_this__u8e3s4) {
    return !(_this__u8e3s4.f1l_1.o1k_1 === 0);
  };
  var SnapshotReason_BEHIND_instance;
  function SnapshotReason$NOT_RELEASE_BRANCH() {
    SnapshotReason.call(this, 'NOT_RELEASE_BRANCH', 3);
    SnapshotReason_NOT_RELEASE_BRANCH_instance = this;
  }
  protoOf(SnapshotReason$NOT_RELEASE_BRANCH).e1l = function (_this__u8e3s4) {
    return !(_this__u8e3s4.f1l_1.p1k_1 === _this__u8e3s4.g1l_1);
  };
  var SnapshotReason_NOT_RELEASE_BRANCH_instance;
  function SnapshotReason$NO_NEW_VERSION() {
    SnapshotReason.call(this, 'NO_NEW_VERSION', 4);
    SnapshotReason_NO_NEW_VERSION_instance = this;
  }
  protoOf(SnapshotReason$NO_NEW_VERSION).e1l = function (_this__u8e3s4) {
    return _this__u8e3s4.h1l_1 === _this__u8e3s4.i1l_1;
  };
  var SnapshotReason_NO_NEW_VERSION_instance;
  function values() {
    return [SnapshotReason_DIRTY_getInstance(), SnapshotReason_AHEAD_getInstance(), SnapshotReason_BEHIND_getInstance(), SnapshotReason_NOT_RELEASE_BRANCH_getInstance(), SnapshotReason_NO_NEW_VERSION_getInstance()];
  }
  function get_entries() {
    if ($ENTRIES == null)
      $ENTRIES = enumEntries(values());
    return $ENTRIES;
  }
  var SnapshotReason_entriesInitialized;
  function SnapshotReason_initEntries() {
    if (SnapshotReason_entriesInitialized)
      return Unit_instance;
    SnapshotReason_entriesInitialized = true;
    SnapshotReason_DIRTY_instance = new SnapshotReason$DIRTY();
    SnapshotReason_AHEAD_instance = new SnapshotReason$AHEAD();
    SnapshotReason_BEHIND_instance = new SnapshotReason$BEHIND();
    SnapshotReason_NOT_RELEASE_BRANCH_instance = new SnapshotReason$NOT_RELEASE_BRANCH();
    SnapshotReason_NO_NEW_VERSION_instance = new SnapshotReason$NO_NEW_VERSION();
  }
  var $ENTRIES;
  function SnapshotReason(name, ordinal) {
    Enum.call(this, name, ordinal);
  }
  protoOf(SnapshotReason).l1l = function (check) {
    return this.e1l(check);
  };
  function calculateNextVersion(_this__u8e3s4, implicitPatch, versionRegex, releaseBranch) {
    var tmp0_elvis_lhs = lastVersionAndTag(_this__u8e3s4);
    var tmp;
    if (tmp0_elvis_lhs == null) {
      return new VersionResult('0.0.0');
    } else {
      tmp = tmp0_elvis_lhs;
    }
    var _destruct__k2r9zo = tmp;
    var previousVersionNumber = _destruct__k2r9zo.qa();
    var lastTagDescription = _destruct__k2r9zo.ra();
    var incrementComponent = findAppropriateIncrement(_this__u8e3s4.u1l_1, lastTagDescription, implicitPatch, versionRegex);
    var tmp2_elvis_lhs = incrementComponent == null ? null : incrementComponent.y1l(asSemverComponents(previousVersionNumber));
    var currentVersionNumber = tmp2_elvis_lhs == null ? previousVersionNumber : tmp2_elvis_lhs;
    var reasonsToUseSnapshot = snapshotReasons(_this__u8e3s4, releaseBranch, currentVersionNumber, previousVersionNumber);
    var tmp_0;
    if (reasonsToUseSnapshot.j()) {
      tmp_0 = new VersionResult(currentVersionNumber);
    } else {
      tmp_0 = new VersionResult(currentVersionNumber + '-SNAPSHOT', reasonsToUseSnapshot);
    }
    return tmp_0;
  }
  function StatusCheck(gitStatus, releaseBranch, currentVersionNumber, previousVersionNumber) {
    this.f1l_1 = gitStatus;
    this.g1l_1 = releaseBranch;
    this.h1l_1 = currentVersionNumber;
    this.i1l_1 = previousVersionNumber;
  }
  protoOf(StatusCheck).toString = function () {
    return 'StatusCheck(gitStatus=' + this.f1l_1.toString() + ', releaseBranch=' + this.g1l_1 + ', currentVersionNumber=' + this.h1l_1 + ', previousVersionNumber=' + this.i1l_1 + ')';
  };
  protoOf(StatusCheck).hashCode = function () {
    var result = this.f1l_1.hashCode();
    result = imul(result, 31) + getStringHashCode(this.g1l_1) | 0;
    result = imul(result, 31) + getStringHashCode(this.h1l_1) | 0;
    result = imul(result, 31) + getStringHashCode(this.i1l_1) | 0;
    return result;
  };
  protoOf(StatusCheck).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof StatusCheck))
      return false;
    var tmp0_other_with_cast = other instanceof StatusCheck ? other : THROW_CCE();
    if (!this.f1l_1.equals(tmp0_other_with_cast.f1l_1))
      return false;
    if (!(this.g1l_1 === tmp0_other_with_cast.g1l_1))
      return false;
    if (!(this.h1l_1 === tmp0_other_with_cast.h1l_1))
      return false;
    if (!(this.i1l_1 === tmp0_other_with_cast.i1l_1))
      return false;
    return true;
  };
  function ChangeType$Major() {
    ChangeType.call(this, 'Major', 0, 3);
    ChangeType_Major_instance = this;
  }
  protoOf(ChangeType$Major).y1l = function (components) {
    // Inline function 'kotlin.collections.component1' call
    var major = components.q(0);
    return '' + (major + 1 | 0) + '.0.0';
  };
  var ChangeType_Major_instance;
  function ChangeType$Minor() {
    ChangeType.call(this, 'Minor', 1, 2);
    ChangeType_Minor_instance = this;
  }
  protoOf(ChangeType$Minor).y1l = function (components) {
    // Inline function 'kotlin.collections.component1' call
    var major = components.q(0);
    // Inline function 'kotlin.collections.component2' call
    var minor = components.q(1);
    return '' + major + '.' + (minor + 1 | 0) + '.0';
  };
  var ChangeType_Minor_instance;
  function ChangeType$Patch() {
    ChangeType.call(this, 'Patch', 2, 1);
    ChangeType_Patch_instance = this;
  }
  protoOf(ChangeType$Patch).y1l = function (components) {
    // Inline function 'kotlin.collections.component1' call
    var major = components.q(0);
    // Inline function 'kotlin.collections.component2' call
    var minor = components.q(1);
    // Inline function 'kotlin.collections.component3' call
    var patch = components.q(2);
    return '' + major + '.' + minor + '.' + (patch + 1 | 0);
  };
  var ChangeType_Patch_instance;
  function ChangeType$None() {
    ChangeType.call(this, 'None', 3, 0);
    ChangeType_None_instance = this;
  }
  protoOf(ChangeType$None).y1l = function (components) {
    // Inline function 'kotlin.collections.component1' call
    var major = components.q(0);
    // Inline function 'kotlin.collections.component2' call
    var minor = components.q(1);
    // Inline function 'kotlin.collections.component3' call
    var patch = components.q(2);
    return '' + major + '.' + minor + '.' + patch;
  };
  var ChangeType_None_instance;
  var ChangeType_entriesInitialized;
  function ChangeType_initEntries() {
    if (ChangeType_entriesInitialized)
      return Unit_instance;
    ChangeType_entriesInitialized = true;
    ChangeType_Major_instance = new ChangeType$Major();
    ChangeType_Minor_instance = new ChangeType$Minor();
    ChangeType_Patch_instance = new ChangeType$Patch();
    ChangeType_None_instance = new ChangeType$None();
  }
  function ChangeType(name, ordinal, priority) {
    Enum.call(this, name, ordinal);
    this.x1l_1 = priority;
  }
  function findAppropriateIncrement(gitAdapter, previousTag, implicitPatch, minorRegex) {
    // Inline function 'kotlin.also' call
    var this_0 = gitAdapter.j1k('HEAD', '^' + previousTag);
    // Inline function 'com.zegreatrob.tools.tagger.core.findAppropriateIncrement.<anonymous>' call
    if (this_0.j())
      return null;
    // Inline function 'kotlin.collections.map' call
    // Inline function 'kotlin.collections.mapTo' call
    var destination = ArrayList_init_$Create$(collectionSizeOrDefault(this_0, 10));
    var _iterator__ex2g4s = this_0.m();
    while (_iterator__ex2g4s.n()) {
      var item = _iterator__ex2g4s.o();
      // Inline function 'com.zegreatrob.tools.tagger.core.findAppropriateIncrement.<anonymous>' call
      var tmp0_elvis_lhs = changeType(item, minorRegex);
      var tmp$ret$1 = tmp0_elvis_lhs == null ? implicitPatch ? ChangeType_Patch_getInstance() : null : tmp0_elvis_lhs;
      destination.e(tmp$ret$1);
    }
    // Inline function 'kotlin.collections.fold' call
    var accumulator = null;
    var _iterator__ex2g4s_0 = destination.m();
    while (_iterator__ex2g4s_0.n()) {
      var element = _iterator__ex2g4s_0.o();
      // Inline function 'com.zegreatrob.tools.tagger.core.findAppropriateIncrement.stub_for_inlining' call
      var p0 = accumulator;
      accumulator = highestPriority(p0, element);
    }
    var tmp0_elvis_lhs_0 = accumulator;
    return tmp0_elvis_lhs_0 == null ? implicitPatch ? ChangeType_Patch_getInstance() : ChangeType_None_getInstance() : tmp0_elvis_lhs_0;
  }
  function snapshotReasons(_this__u8e3s4, releaseBranch, currentVersionNumber, previousVersionNumber) {
    // Inline function 'kotlin.let' call
    // Inline function 'com.zegreatrob.tools.tagger.core.snapshotReasons.<anonymous>' call
    var statusCheck = new StatusCheck(_this__u8e3s4.u1l_1.k1k(), releaseBranch, currentVersionNumber, previousVersionNumber);
    // Inline function 'kotlin.collections.filter' call
    var tmp0 = get_entries();
    // Inline function 'kotlin.collections.filterTo' call
    var destination = ArrayList_init_$Create$_0();
    var _iterator__ex2g4s = tmp0.m();
    while (_iterator__ex2g4s.n()) {
      var element = _iterator__ex2g4s.o();
      // Inline function 'com.zegreatrob.tools.tagger.core.snapshotReasons.<anonymous>.<anonymous>' call
      if (element.l1l(statusCheck)) {
        destination.e(element);
      }
    }
    return destination;
  }
  function highestPriority(left, right) {
    return left == null ? right : right == null ? left : left.x1l_1 > right.x1l_1 ? left : right;
  }
  function changeType(_this__u8e3s4, versionRegex) {
    // Inline function 'kotlin.text.trim' call
    var this_0 = _this__u8e3s4.b1k_1;
    var tmp$ret$0 = toString(trim(isCharSequence(this_0) ? this_0 : THROW_CCE()));
    return changeType_0(versionRegex, tmp$ret$0);
  }
  function changeType_0(_this__u8e3s4, message) {
    var tmp;
    var tmp0_safe_receiver = _this__u8e3s4.p1m_1;
    if ((tmp0_safe_receiver == null ? null : tmp0_safe_receiver.zc(message)) === true) {
      tmp = findMatchType(message, _this__u8e3s4.p1m_1);
    } else {
      if (_this__u8e3s4.o1m_1.zc(message)) {
        tmp = ChangeType_Major_getInstance();
      } else {
        if (_this__u8e3s4.n1m_1.zc(message)) {
          tmp = ChangeType_Minor_getInstance();
        } else {
          if (_this__u8e3s4.m1m_1.zc(message)) {
            tmp = ChangeType_Patch_getInstance();
          } else {
            if (_this__u8e3s4.l1m_1.zc(message)) {
              tmp = ChangeType_None_getInstance();
            } else {
              tmp = null;
            }
          }
        }
      }
    }
    return tmp;
  }
  function findMatchType(message, regex) {
    var tmp0_safe_receiver = regex.dd(message);
    var groups = tmp0_safe_receiver == null ? null : tmp0_safe_receiver.ld();
    return groupExists(groups, 'major') ? ChangeType_Major_getInstance() : groupExists(groups, 'minor') ? ChangeType_Minor_getInstance() : groupExists(groups, 'patch') ? ChangeType_Patch_getInstance() : groupExists(groups, 'none') ? ChangeType_None_getInstance() : null;
  }
  function groupExists(_this__u8e3s4, groupName) {
    // Inline function 'kotlin.runCatching' call
    var tmp;
    try {
      // Inline function 'com.zegreatrob.tools.tagger.core.groupExists.<anonymous>' call
      // Inline function 'kotlin.Companion.success' call
      var value = !((_this__u8e3s4 == null ? null : get(_this__u8e3s4, groupName)) == null);
      tmp = _Result___init__impl__xyqfz8(value);
    } catch ($p) {
      var tmp_0;
      if ($p instanceof Error) {
        var e = $p;
        // Inline function 'kotlin.Companion.failure' call
        tmp_0 = _Result___init__impl__xyqfz8(createFailure(e));
      } else {
        throw $p;
      }
      tmp = tmp_0;
    }
    var tmp2 = tmp;
    var tmp$ret$4;
    $l$block: {
      // Inline function 'kotlin.getOrDefault' call
      if (_Result___get_isFailure__impl__jpiriv(tmp2)) {
        tmp$ret$4 = false;
        break $l$block;
      }
      var tmp_1 = _Result___get_value__impl__bjfvqg(tmp2);
      tmp$ret$4 = (tmp_1 == null ? true : !(tmp_1 == null)) ? tmp_1 : THROW_CCE();
    }
    return tmp$ret$4;
  }
  function SnapshotReason_DIRTY_getInstance() {
    SnapshotReason_initEntries();
    return SnapshotReason_DIRTY_instance;
  }
  function SnapshotReason_AHEAD_getInstance() {
    SnapshotReason_initEntries();
    return SnapshotReason_AHEAD_instance;
  }
  function SnapshotReason_BEHIND_getInstance() {
    SnapshotReason_initEntries();
    return SnapshotReason_BEHIND_instance;
  }
  function SnapshotReason_NOT_RELEASE_BRANCH_getInstance() {
    SnapshotReason_initEntries();
    return SnapshotReason_NOT_RELEASE_BRANCH_instance;
  }
  function SnapshotReason_NO_NEW_VERSION_getInstance() {
    SnapshotReason_initEntries();
    return SnapshotReason_NO_NEW_VERSION_instance;
  }
  function ChangeType_Major_getInstance() {
    ChangeType_initEntries();
    return ChangeType_Major_instance;
  }
  function ChangeType_Minor_getInstance() {
    ChangeType_initEntries();
    return ChangeType_Minor_instance;
  }
  function ChangeType_Patch_getInstance() {
    ChangeType_initEntries();
    return ChangeType_Patch_instance;
  }
  function ChangeType_None_getInstance() {
    ChangeType_initEntries();
    return ChangeType_None_instance;
  }
  function lastVersionAndTag(_this__u8e3s4) {
    var tmp0_elvis_lhs = _this__u8e3s4.u1l_1.l1k(0);
    var tmp;
    if (tmp0_elvis_lhs == null) {
      return null;
    } else {
      tmp = tmp0_elvis_lhs;
    }
    var description = tmp;
    var tmp_0;
    if (contains(description, '-')) {
      tmp_0 = substringBefore(description, '-');
    } else {
      tmp_0 = description;
    }
    var previousVersionNumber = tmp_0;
    // Inline function 'kotlin.text.ifEmpty' call
    var tmp_1;
    // Inline function 'kotlin.text.isEmpty' call
    if (charSequenceLength(previousVersionNumber) === 0) {
      // Inline function 'com.zegreatrob.tools.tagger.core.lastVersionAndTag.<anonymous>' call
      tmp_1 = null;
    } else {
      tmp_1 = previousVersionNumber;
    }
    var tmp1_safe_receiver = tmp_1;
    var tmp_2;
    if (tmp1_safe_receiver == null) {
      tmp_2 = null;
    } else {
      // Inline function 'kotlin.let' call
      // Inline function 'com.zegreatrob.tools.tagger.core.lastVersionAndTag.<anonymous>' call
      tmp_2 = to(tmp1_safe_receiver, description);
    }
    return tmp_2;
  }
  function tag(_this__u8e3s4, version, releaseBranch, userName, userEmail) {
    var isSnapshot_0 = isSnapshot(version);
    var headTag = _this__u8e3s4.u1l_1.i1k('HEAD');
    var alreadyTagged = !(headTag == null);
    var headBranch = _this__u8e3s4.u1l_1.k1k().p1k_1;
    var isNotOnReleaseBranch = !(headBranch === releaseBranch);
    var tmp;
    if (isSnapshot_0 || alreadyTagged || isNotOnReleaseBranch) {
      var tmp_0 = TagErrors_instance;
      var tmp_1 = to(isSnapshot_0, 'being snapshot');
      var tmp_2 = TagErrors_instance;
      // Inline function 'kotlin.collections.filterKeys' call
      var this_0 = mapOf([tmp_1, to(alreadyTagged, tmp_2.r1m(headTag == null ? null : headTag.r1k_1)), to(isNotOnReleaseBranch, TagErrors_instance.s1m(releaseBranch, headBranch))]);
      var result = LinkedHashMap_init_$Create$();
      // Inline function 'kotlin.collections.iterator' call
      var _iterator__ex2g4s = this_0.x().m();
      while (_iterator__ex2g4s.n()) {
        var entry = _iterator__ex2g4s.o();
        // Inline function 'com.zegreatrob.tools.tagger.core.tag.<anonymous>' call
        if (entry.y()) {
          result.m2(entry.y(), entry.z());
        }
      }
      tmp = new Error_0(tmp_0.t1m(joinToString(result.g2(), ', ')));
    } else {
      // Inline function 'kotlin.runCatching' call
      var tmp_3;
      try {
        _this__u8e3s4.u1l_1.g1k(version, 'HEAD', userName, userEmail);
        // Inline function 'kotlin.Companion.success' call
        tmp_3 = _Result___init__impl__xyqfz8(Unit_instance);
      } catch ($p) {
        var tmp_4;
        if ($p instanceof Error) {
          var e = $p;
          // Inline function 'kotlin.Companion.failure' call
          tmp_4 = _Result___init__impl__xyqfz8(createFailure(e));
        } else {
          throw $p;
        }
        tmp_3 = tmp_4;
      }
      // Inline function 'kotlin.map' call
      var this_1 = tmp_3;
      var tmp_5;
      if (_Result___get_isSuccess__impl__sndoy8(this_1)) {
        var tmp_6 = _Result___get_value__impl__bjfvqg(this_1);
        // Inline function 'com.zegreatrob.tools.tagger.core.tag.<anonymous>' call
        (tmp_6 == null ? true : !(tmp_6 == null)) || THROW_CCE();
        _this__u8e3s4.u1l_1.h1k();
        // Inline function 'kotlin.Companion.success' call
        var value = Success_getInstance();
        tmp_5 = _Result___init__impl__xyqfz8(value);
      } else {
        tmp_5 = _Result___init__impl__xyqfz8(_Result___get_value__impl__bjfvqg(this_1));
      }
      // Inline function 'kotlin.getOrElse' call
      var this_2 = tmp_5;
      var exception = Result__exceptionOrNull_impl_p6xea9(this_2);
      var tmp_7;
      if (exception == null) {
        var tmp_8 = _Result___get_value__impl__bjfvqg(this_2);
        tmp_7 = (tmp_8 == null ? true : !(tmp_8 == null)) ? tmp_8 : THROW_CCE();
      } else {
        // Inline function 'com.zegreatrob.tools.tagger.core.tag.<anonymous>' call
        var tmp0_elvis_lhs = exception.message;
        tmp_7 = new Error_0(tmp0_elvis_lhs == null ? 'Unknown error during tagging' : tmp0_elvis_lhs);
      }
      tmp = tmp_7;
    }
    return tmp;
  }
  function isSnapshot(_this__u8e3s4) {
    return contains(_this__u8e3s4, 'SNAPSHOT');
  }
  function TagErrors() {
    this.q1m_1 = 'being snapshot';
  }
  protoOf(TagErrors).t1m = function (messages) {
    return 'skipping tag due to ' + messages;
  };
  protoOf(TagErrors).r1m = function (headTag) {
    return 'already tagged ' + headTag;
  };
  protoOf(TagErrors).s1m = function (releaseBranch, headBranch) {
    return 'not on release branch ' + releaseBranch + ' - branch was ' + headBranch;
  };
  var TagErrors_instance;
  function TagErrors_getInstance() {
    return TagErrors_instance;
  }
  function Success() {
    Success_instance = this;
    TagResult.call(this);
  }
  protoOf(Success).toString = function () {
    return 'Success';
  };
  protoOf(Success).hashCode = function () {
    return -888110432;
  };
  protoOf(Success).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof Success))
      return false;
    other instanceof Success || THROW_CCE();
    return true;
  };
  var Success_instance;
  function Success_getInstance() {
    if (Success_instance == null)
      new Success();
    return Success_instance;
  }
  function Error_0(message) {
    TagResult.call(this);
    this.u1m_1 = message;
  }
  protoOf(Error_0).toString = function () {
    return 'Error(message=' + this.u1m_1 + ')';
  };
  protoOf(Error_0).hashCode = function () {
    return getStringHashCode(this.u1m_1);
  };
  protoOf(Error_0).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof Error_0))
      return false;
    var tmp0_other_with_cast = other instanceof Error_0 ? other : THROW_CCE();
    if (!(this.u1m_1 === tmp0_other_with_cast.u1m_1))
      return false;
    return true;
  };
  function TagResult() {
  }
  function TaggerCore(adapter) {
    this.u1l_1 = adapter;
  }
  protoOf(TaggerCore).toString = function () {
    return 'TaggerCore(adapter=' + toString(this.u1l_1) + ')';
  };
  protoOf(TaggerCore).hashCode = function () {
    return hashCode(this.u1l_1);
  };
  protoOf(TaggerCore).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof TaggerCore))
      return false;
    var tmp0_other_with_cast = other instanceof TaggerCore ? other : THROW_CCE();
    if (!equals(this.u1l_1, tmp0_other_with_cast.u1l_1))
      return false;
    return true;
  };
  function Defaults() {
    Defaults_instance = this;
    this.v1m_1 = Defaults_getInstance().x1k_1;
    this.w1m_1 = Defaults_getInstance().w1k_1;
    this.x1m_1 = Defaults_getInstance().v1k_1;
    this.y1m_1 = Defaults_getInstance().u1k_1;
  }
  var Defaults_instance;
  function Defaults_getInstance_0() {
    if (Defaults_instance == null)
      new Defaults();
    return Defaults_instance;
  }
  function Companion() {
    this.z1m_1 = "version regex must include groups named 'major', 'minor', 'patch', and 'none'.";
  }
  protoOf(Companion).a1n = function (regexPattern) {
    return contains(regexPattern, '?<major>') && contains(regexPattern, '?<minor>') && contains(regexPattern, '?<patch>') && contains(regexPattern, '?<none>');
  };
  var Companion_instance_0;
  function Companion_getInstance() {
    return Companion_instance_0;
  }
  function VersionRegex(none, patch, minor, major, unified) {
    this.l1m_1 = none;
    this.m1m_1 = patch;
    this.n1m_1 = minor;
    this.o1m_1 = major;
    this.p1m_1 = unified;
  }
  protoOf(VersionRegex).toString = function () {
    return 'VersionRegex(none=' + this.l1m_1.toString() + ', patch=' + this.m1m_1.toString() + ', minor=' + this.n1m_1.toString() + ', major=' + this.o1m_1.toString() + ', unified=' + toString_0(this.p1m_1) + ')';
  };
  protoOf(VersionRegex).hashCode = function () {
    var result = hashCode(this.l1m_1);
    result = imul(result, 31) + hashCode(this.m1m_1) | 0;
    result = imul(result, 31) + hashCode(this.n1m_1) | 0;
    result = imul(result, 31) + hashCode(this.o1m_1) | 0;
    result = imul(result, 31) + (this.p1m_1 == null ? 0 : hashCode(this.p1m_1)) | 0;
    return result;
  };
  protoOf(VersionRegex).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof VersionRegex))
      return false;
    var tmp0_other_with_cast = other instanceof VersionRegex ? other : THROW_CCE();
    if (!equals(this.l1m_1, tmp0_other_with_cast.l1m_1))
      return false;
    if (!equals(this.m1m_1, tmp0_other_with_cast.m1m_1))
      return false;
    if (!equals(this.n1m_1, tmp0_other_with_cast.n1m_1))
      return false;
    if (!equals(this.o1m_1, tmp0_other_with_cast.o1m_1))
      return false;
    if (!equals(this.p1m_1, tmp0_other_with_cast.p1m_1))
      return false;
    return true;
  };
  //region block: init
  TagErrors_instance = new TagErrors();
  Companion_instance_0 = new Companion();
  //endregion
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = Error_0;
  _.$_$.b = TaggerCore;
  _.$_$.c = VersionRegex;
  _.$_$.d = calculateNextVersion;
  _.$_$.e = tag;
  _.$_$.f = Success_getInstance;
  _.$_$.g = Companion_instance_0;
  _.$_$.h = Defaults_getInstance_0;
  //endregion
  return _;
}(module.exports, require('./kotlin-kotlin-stdlib.js'), require('./tools-digger-core.js')));

//# sourceMappingURL=tools-tagger-core.js.map
